unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, ScktComp ;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    bt_stop: TButton;
    Timer1: TTimer;
    mm_receive: TMemo;
    ClientSocket1: TClientSocket;
    procedure FormCreate(Sender: TObject);
    procedure bt_stopClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ClientSocket1Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientSocket1Disconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Error(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  FileName : String;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  BackupName : String;
begin
  ClientSocket1.Port := 8000;
  if ParamStr( 1 ) <> '' then
    ClientSocket1.Address := paramstr(1)
  else
  begin
    showmessage('please start like this: tk_cs.exe <ip address> <file name>');
    application.terminate;
  end;    
  if ParamStr( 2 ) <> '' then
  begin
    filename := ParamStr( 2 );
    if FileExists(FileName) then
    begin
      mm_receive.Lines.LoadFromFile(filename);
      mm_receive.SelStart := Length(mm_receive.Text);
      mm_receive.Perform(EM_SCROLLCARET, 0, 0);
      BackupName := ExtractFileName(FileName);
      BackupName := ChangeFileExt(BackupName, '.BAK');
      RenameFile(FileName, BackupName);
    end;
    ClientSocket1.Active := true;
  end
  else
  begin
    showmessage('please start like this: tk_cs.exe <ip address> <file name>');
    application.Terminate
  end;
end;

procedure TForm1.ClientSocket1Connect(Sender: TObject;
  Socket: TCustomWinSocket);
var
  sendstring : string;
begin
  sendstring :=  #27#02#13;
  statusbar1.SimpleText := 'connected to ' + ClientSocket1.Address;
  ClientSocket1.Socket.SendText(sendstring);
  timer1.Enabled := true;
end;

procedure TForm1.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   timer1.Enabled := false;
   mm_receive.Text := mm_receive.text + ClientSocket1.Socket.ReceiveText;
   mm_receive.SelStart := Length(mm_receive.Text);
   mm_receive.Perform(EM_SCROLLCARET, 0, 0);
   timer1.Enabled := true;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var filehandle : integer;
sendstring : string;
begin
  sendstring := #27#03#13;
  timer1.Enabled := false;
  ClientSocket1.Socket.SendText(sendstring);
  sleep(200);
  ClientSocket1.Active := false;
  if fileexists(filename) = false then
  begin
    filehandle := filecreate(filename);
    fileclose(filehandle);
  end;
  mm_receive.Lines.SaveToFile( filename );
  application.Terminate;
end;

procedure TForm1.bt_stopClick(Sender: TObject);
var filehandle : integer;
    sendstring : string;
begin
  sendstring :=  #27#03#13;
  timer1.Enabled := false;
  ClientSocket1.Socket.SendText(sendstring);
  sleep(200);
  ClientSocket1.Active := false;
  if fileexists(filename) = false then
  begin
    filehandle := filecreate(filename);
    fileclose(filehandle);
  end;
  mm_receive.Lines.SaveToFile( filename );
  application.Terminate;
end;

procedure TForm1.ClientSocket1Disconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  ClientSocket1.Active := false;
  statusbar1.SimpleText := 'no connetion';
end;

procedure TForm1.ClientSocket1Error(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
var
  filehandle : integer;  
begin
  ErrorCode := 0;
  statusbar1.SimpleText := 'connection error';
  timer1.Enabled := false;
  ClientSocket1.Active := false;
  if fileexists(filename) = false then
  begin
    filehandle := filecreate(filename);
    fileclose(filehandle);
  end;
  mm_receive.Lines.SaveToFile( filename );
  application.Terminate;
end;








end.
